//////////////////////////////////////////////////////////////////////////////////////////////
/// \file
/// \brief
/// \details
/// \author Frederik Lange
/// \date
/// \copyright Copyright (C) 2018 University of Oxford
//////////////////////////////////////////////////////////////////////////////////////////////
#include "MmorfMemory.h"
#include "CLASS.HEADER"

#include <memory>

namespace MMORF
{
////////////////////////////////////////////////////////////////////////////////
// PIMPL Class
////////////////////////////////////////////////////////////////////////////////
  class CLASS::Impl
  {
    public:
    private:
  };
////////////////////////////////////////////////////////////////////////////////
// Main Class
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Rule of 5
////////////////////////////////////////////////////////////////////////////////
  /// Default dtor
  CLASS::~CLASS() = default;
  /// Move ctor
  CLASS::CLASS(CLASS&& rhs) = default;
  /// Move assignment operator
  CLASS& CLASS::operator=(CLASS&& rhs) = default;
  /// Copy ctor
  CLASS::CLASS(const CLASS& rhs)
  : pimpl_(nullptr)
  {
    if (rhs.pimpl_){
      pimpl_ = MMORF::make_unique<Impl>(*rhs.pimpl_);
    }
  }
  /// Copy assignment operator
  CLASS& CLASS::operator=(const CLASS& rhs)
  {
    if (!rhs.pimpl_){
      pimpl_.reset();
    }
    else if (!pimpl_){
      pimpl_ = MMORF::make_unique<Impl>(*rhs.pimpl_);
    }
    else{
      *pimpl_ = *rhs.pimpl_;
    }
    return *this;
  }
////////////////////////////////////////////////////////////////////////////////
// Class Specific Functions
////////////////////////////////////////////////////////////////////////////////
  /// Default ctor
  CLASS::CLASS()
    : pimpl_(MMORF::make_unique<Impl>())
  {}
} // MMORF
